
$vhdPath = "c:\vhd\WinpeV1809-generation2.vhdx"
$vhdSize = 10GB
$BootWimPath = "C:\Users\noelBlanc\Documents\MicroWinpeBuilder-1809-en\Build\media\sources\boot.wim"
$Index = 1

New-VHD -Path $vhdPath -SizeBytes $vhdSize -Fixed
Mount-VHD -Path $vhdPath
$disk = get-vhd -path $vhdPath
Initialize-Disk $disk.DiskNumber

#
# Create system partition  --->>> ESR fat32 for BCD and UEFI/GPT
#
# get-help  New-Partition -full --> System Partition = (c12a7328-f81f-11d2-ba4b-00a0c93ec93b) 
#$systemPartition = New-Partition -DiskNumber $disk.DiskNumber -GptType '{c12a7328-f81f-11d2-ba4b-00a0c93ec93bc}' -Size 100MB -AssignDriveLetter
# error : New-Partition : The specified partition type is not valid.
$systemPartition = New-Partition -DiskNumber $disk.DiskNumber -Size 100MB -AssignDriveLetter
$volumeESR = Format-Volume -FileSystem FAT32 -Confirm:$false -Force -Partition $systemPartition -NewFileSystemLabel "Winpe_Uefi"
$systemDrive = "$($volumeESR.DriveLetter):"

#
# Create windows partition  --->>> pour l'os winpe
#
$WinpePartition = New-Partition -DiskNumber $disk.DiskNumber -UseMaximumSize -AssignDriveLetter
$volumeWinpe = Format-Volume -FileSystem NTFS -Confirm:$false -Force -Partition $WinpePartition -NewFileSystemLabel "Winpe_V1809"
$WinpeDrive = "$($volumeWinpe.DriveLetter):"

#
# Apply boot.wim
#
# idem dism /apply-image ....
Expand-WindowsImage -ImagePath $BootWimPath -Index $Index -ApplyPath $WinpeDrive

#
# install boot for UEFI : semble ne pouvoir tre fait qu'aprs le dism /apply-image...
#
$windir = "$WinpeDrive\windows"
#$cmd = "$windir\System32\bcdboot.exe $windir /s $systemDrive /F UEFI"
#pour vrifier si on peut booter depuis une cl usb sur le vhdx
$cmd = "$windir\System32\bcdboot.exe $windir /s $systemDrive /F ALL"
Invoke-Expression $cmd

# winpe dans uefi/GPT
$cmd = "bcdedit /store $systemDrive\EFI\Microsoft\Boot\BCD /set '{default}' Winpe YES"
Invoke-Expression $cmd

$cmd = "bcdedit /store $systemDrive\EFI\Microsoft\Boot\BCD /set '{default}' testsigning YES"
Invoke-Expression $cmd

$cmd = "bcdedit /store $systemDrive\EFI\Microsoft\Boot\BCD /set '{default}' bootlog YES"
Invoke-Expression $cmd

#winpe dans bios/MBR
$cmd = "bcdedit /store $systemDrive\Boot\BCD /set '{default}' Winpe YES"
Invoke-Expression $cmd

$cmd = "bcdedit /store $systemDrive\Boot\BCD /set '{default}' testsigning YES"
Invoke-Expression $cmd

$cmd = "bcdedit /store $systemDrive\Boot\BCD /set '{default}' bootlog YES"
Invoke-Expression $cmd

#
# dmonte le vhdx
#
Dismount-VHD -Path $vhdPath

#
# place the vhdx dans la vm
#
Add-VMHardDiskDrive -VMName generation2 -Path $vhdPath

<#
#create the VM
$vmParams = @{
Name = "Demo Gen 2" 
Generation = 2 
VHDPath = $diskParams.path 
MemoryStartupBytes = 1GB
SwitchName = "Work Network"
}
 
#modify VM parameters
$setParams = @{
ProcessorCount = 2
DynamicMemory =$True
MemoryMaximumBytes = 2GB
Notes = "demonstration Gen 2 VM"
Passthru = $True
 
}
 
#create the VM and start it
Write-Host "$(get-date) Creating, modifying and starting the VM" -ForegroundColor Green
 
New-VM @vmParams | Set-VM @setParams | Start-VM
 
#>