﻿#Requires -Version 5.0
##Requires -RunAsAdministrator

#v3.0 modif titre avec version 1903 build 18362.19h1 et V1909
#         ajout du fichier NotificationsOobeComplete.txt pour printers

#v2.0 modif titre avec version 1809 build 17763.134 rs5
#         Suppression definitive de fileSetWow64 fileModifyTheme 

#v1.0 modif titre avec version 1803 build 17134 rs4

#v0.7 ajout fichier pour terminalServer
#v0.6 modif titre avec version 1709 build 16299, ajout nom fichier pour menu New et visualiser les imp
#v0.5 modif titre avec build 15063
#v0.4 bug Language En-us in Avril 2017
#v0.3 ajout script resolution d'écran
#v0.2 modif titre avec build 14393
#v0.1.h 
#        - Ajout choix trace réseau et session adm
#v0.1.g
#        - correction proposées par 'sezz' : resizing the form
#        - textes en anglais
#v0.1.f : V3 sur theoven
#       - modification du passage des paramètres
#v0.1.e
#       - test des fichiers utiles
#v0.1.d
#       - bug si lecture fichier de config : pas de lecture automatique de la langue
#       - ajout build de la ref dans un $toolStripStatusLabel_BuildRef
#v0.1.c
#    ajout de la détection automatique de la langue lue dans la référence. Cela impose :
#       - load/unload de la ruche à partir de l'ihm avec les pb potentiels de handles du PS non libérés
#       - et surtout de copier le code C# pour activer les droits SE_RESTORE_NAME et SE_BACKUP_NAME pour ce runspace
#v0.1.b

# http://learn-powershell.net/2013/04/19/sharing-variables-and-live-objects-between-powershell-runspaces/
# https://www.sapien.com/blog/2012/07/05/spotlight-on-the-statusbar-control/

# debug = les write-host sont envoyés dans la console PS
# mais cela complique un peu le passage des paramètres !
param( [switch]$Debug = $false )

Add-Type -AssemblyName "system.windows.forms"
Add-Type -AssemblyName "System.Drawing"

$sb = {
# les variables
$NomDeBase =  "MicroWinpeBuilder"
$NomDuFichierDeConfig = "$NomDeBase.config"
#recevra le contenu du fichier de config
$htab_Config = @{}
$PathSrcHiveRef = ""
$NameSrcHiveRef = "tmp_ref_sys"
#region Fonctions
function init{

    lire-config

    # lire les textes en anglais
    if ($PSCulture -ne "fr-FR"){
        $text = gc $fileEnglishText | Out-String
        # faut il tester si le fichier contient le nom de la variable ?
        &( [scriptblock]::Create($text))
        $textBox4.Text              = $TextPresentation 
        $label_HelpSaveConfig.Text  = $label_HelpSaveConfigText
        $tabPage_Presentation.Text  = $tabTextPresentation
        $tabPage_Saisie.Text        = $tabTextSaisie
        $tabPage_Configuration.Text = $tabTextConfiguration
        $tabPage_Console.Text       = $tabTextConsole
        $groupBox3.Text             = $groupbox3Text
        $groupBox2.Text             = $groupbox2Text
        $groupBox1.Text             = $groupbox1Text
   }

    #$textBox_racine.Text = "$HOME\documents"
    #[System.Environment+SpecialFolder]::MyDocuments
    $textBox_Racine.Text = join-path ([Environment]::GetFolderPath('MyDocuments')) $NomDeBase
    if ($htab_Config.ContainsKey("racine")){
        $textBox_Racine.Text =  $htab_Config.get_item("racine")
    }

    # if exist HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\Microsoft\Windows Kits\Installed Roots KitsRoot10  C:\Program Files (x86)\Windows Kits\10\
    $textBox_srcAdk.Text = [System.Environment+SpecialFolder]::ProgramFilesX86
    $keyAdk = "HKLM:\SOFTWARE\Wow6432Node\Microsoft\Windows Kits\Installed Roots"
    if (test-path $keyAdk){
         $textBox_SrcAdk.Text = (gp -Path $keyAdk -Name KitsRoot10).KitsRoot10
    }
    if ($htab_Config.ContainsKey("srcAdk")){
        $textBox_SrcAdk.Text = $htab_Config.get_item("srcAdk")
    }

    $radioButton3.Checked = $true

    $textBox_refWindows.Text = ""
    if ($htab_Config.ContainsKey("refWindows")){
        $textBox_RefWindows.Text = $htab_Config.get_item("refWindows")
    } 
    #si on a lu les info dans le fichier de config alors on lit les' build' et 'la langue de la ref'
    # dans mon cas, j'utilise un disque usb externe et s'il n'est pas branché, l'ihm n'est pas affiché
    if (test-path $($textBox_RefWindows.Text)) {
        & $button_GetInfoWim_OnClick
    }
}
#region lire/ecrire config
function ecrire-config ([string]$racine , [string]$srcAdk, [string]$refWindows ){
    # mise à jour de la hashtab
    if ($htab_Config.ContainsKey("racine")){
        $htab_Config.set_item("racine",$racine)
    }else{
         $htab_Config.add("racine",$racine)
    }

    if ($htab_Config.ContainsKey("srcAdk")){
        $htab_Config.set_item("srcAdk",$srcAdk)
    }else{
         $htab_Config.add("srcAdk",$srcAdk)
    }

    if ($htab_Config.ContainsKey("refWindows")){
        $htab_Config.set_item("refWindows",$refWindows)
    }else{
         $htab_Config.add("refWindows",$refWindows)
    }

    # mise à jour du fichier depuis la htab
    ($htab_Config.keys | foreach {"$_=$($htab_Config.item($_))"} ) -join "`r`n" | sc  $global:configFile -Encoding Ascii
}
function lire-config{
    # racine=c:\toto
    # srcAdk=c:\titi
    # refWindows=c:\tutu
    $global:configFile = get-nameFileConfig
    # pb : test-path est il ok pour les flux alternatif ? Oui
    if (test-path $global:configFile ){
        $l=gc $global:configFile
        $l | ? {$l[0] -ne ";"} | %{
            $htab_Config.add( ($_.split("="))[0] , ($_.split("="))[1])
        }
    }
    #[System.Windows.Forms.MessageBox]::Show($htab_Config)
}
function get-nameFileConfig(){
    # passage de paramètres dans le Runspace depuis le script parent
    #[System.Windows.Forms.MessageBox]::Show("monPSScriptRoot=$monPSScriptRoot MonScript =$MonScript ")
    if ( $monPSScriptRoot -eq $null){
        $configFile  = join-path $PSScriptRoot $NomDuFichierDeConfig    
    }else{
        $configFile  = join-path $monPSScriptRoot $NomDuFichierDeConfig
    }
    # si on utilise le flux alternatif pour stocker les info
    if ( $MonScript -ne $null){
        $configFile  = join-path $monPSScriptRoot "$MonScript`:$NomDuFichierDeConfig"
    }
    $configFile
}
#endregion lire/ecrire config

#region ruches et privilèges
function enable-privilege {
 param(
  ## The privilege to adjust. This set is taken from
  ## http://msdn.microsoft.com/en-us/library/bb530716(VS.85).aspx
  [ValidateSet(
   "SeAssignPrimaryTokenPrivilege", "SeAuditPrivilege", "SeBackupPrivilege",
   "SeChangeNotifyPrivilege", "SeCreateGlobalPrivilege", "SeCreatePagefilePrivilege",
   "SeCreatePermanentPrivilege", "SeCreateSymbolicLinkPrivilege", "SeCreateTokenPrivilege",
   "SeDebugPrivilege", "SeEnableDelegationPrivilege", "SeImpersonatePrivilege", "SeIncreaseBasePriorityPrivilege",
   "SeIncreaseQuotaPrivilege", "SeIncreaseWorkingSetPrivilege", "SeLoadDriverPrivilege",
   "SeLockMemoryPrivilege", "SeMachineAccountPrivilege", "SeManageVolumePrivilege",
   "SeProfileSingleProcessPrivilege", "SeRelabelPrivilege", "SeRemoteShutdownPrivilege",
   "SeRestorePrivilege", "SeSecurityPrivilege", "SeShutdownPrivilege", "SeSyncAgentPrivilege",
   "SeSystemEnvironmentPrivilege", "SeSystemProfilePrivilege", "SeSystemtimePrivilege",
   "SeTakeOwnershipPrivilege", "SeTcbPrivilege", "SeTimeZonePrivilege", "SeTrustedCredManAccessPrivilege",
   "SeUndockPrivilege", "SeUnsolicitedInputPrivilege")]
  $Privilege,
  ## The process on which to adjust the privilege. Defaults to the current process.
  $ProcessId = $pid,
  ## Switch to disable the privilege, rather than enable it.
  [Switch] $Disable
 )

 ## Taken from P/Invoke.NET with minor adjustments.
 $definition = @'
 using System;
 using System.Runtime.InteropServices;
  
 public class AdjPriv
 {
  [DllImport("advapi32.dll", ExactSpelling = true, SetLastError = true)]
  internal static extern bool AdjustTokenPrivileges(IntPtr htok, bool disall,
   ref TokPriv1Luid newst, int len, IntPtr prev, IntPtr relen);
  
  [DllImport("advapi32.dll", ExactSpelling = true, SetLastError = true)]
  internal static extern bool OpenProcessToken(IntPtr h, int acc, ref IntPtr phtok);
  [DllImport("advapi32.dll", SetLastError = true)]
  internal static extern bool LookupPrivilegeValue(string host, string name, ref long pluid);
  [StructLayout(LayoutKind.Sequential, Pack = 1)]
  internal struct TokPriv1Luid
  {
   public int Count;
   public long Luid;
   public int Attr;
  }
  
  internal const int SE_PRIVILEGE_ENABLED = 0x00000002;
  internal const int SE_PRIVILEGE_DISABLED = 0x00000000;
  internal const int TOKEN_QUERY = 0x00000008;
  internal const int TOKEN_ADJUST_PRIVILEGES = 0x00000020;
  public static bool EnablePrivilege(long processHandle, string privilege, bool disable)
  {
   bool retVal;
   TokPriv1Luid tp;
   IntPtr hproc = new IntPtr(processHandle);
   IntPtr htok = IntPtr.Zero;
   retVal = OpenProcessToken(hproc, TOKEN_ADJUST_PRIVILEGES | TOKEN_QUERY, ref htok);
   tp.Count = 1;
   tp.Luid = 0;
   if(disable)
   {
    tp.Attr = SE_PRIVILEGE_DISABLED;
   }
   else
   {
    tp.Attr = SE_PRIVILEGE_ENABLED;
   }
   retVal = LookupPrivilegeValue(null, privilege, ref tp.Luid);
   retVal = AdjustTokenPrivileges(htok, false, ref tp, 0, IntPtr.Zero, IntPtr.Zero);
   return retVal;
  }
 }
'@
 #if (-not ("AdjPriv" -as [Type]))
 #{
    $type = Add-Type $definition -PassThru
 #}
 $processHandle = (Get-Process -id $ProcessId).Handle
 $type[0]::EnablePrivilege($processHandle, $Privilege, $Disable)
}

$codeRuches=@'
using System;
using Microsoft.Win32;
using System.Runtime.InteropServices;
namespace HiveWork
{
    public class Hives
    {
        [DllImport("advapi32.dll", CharSet = CharSet.Auto, SetLastError = true)]
        public static extern int RegLoadKey(uint hKey, string lpSubKey, string lpFile);
        [DllImport("advapi32.dll", CharSet = CharSet.Auto, SetLastError = true)]
        public static extern int RegUnLoadKey(uint hKey, string lpSubKey);

        public static int RegUnLoadKey_(uint hKey, string lpSubKey){
            return  (RegUnLoadKey(hKey, lpSubKey));
        }
        public static int RegLoadKey_(uint hKey, string lpSubKey, string lpFile){
            return  (RegLoadKey(hKey, lpSubKey, lpFile));
        }
    }
}
'@
if (-not ("HiveWork.Hives" -as [Type]))
{
    Add-Type  -TypeDefinition $codeRuches
}

# "{0:x}" -f [System.UInt32]2147483651 = 0x80000003 = HKU
# erreur unload : 1314 ???
function UnloadRuche ( [string] $HiveName ){
    $res = [HiveWork.Hives]::RegUnLoadKey_(([System.UInt32]2147483651), $HiveName) 
    if( -not ($res -eq 0  -OR $res -eq 87) ){
        Throw "Erreur win32_UnLOAD : $res."
    }
}
function LoadRuche ( [string] $HiveName, [string] $HiveFile ){
    if ( Test-Path $HiveFile){
        $res = [HiveWork.Hives]::RegLoadKey_(([System.UInt32]2147483651), $HiveName, $HiveFile) 
        if($res -ne 0){
            Throw "Erreur win32_LOAD : $res."
        }
    }else{
            Throw "fichier absent : $HiveFile"
    }
}
#endregion ruches et privilège
function GetInfoWim($WinpeFile, $RefFile){
    $ErrorActionPreference="stop"
    $build ="?"
    $v ="?"
    $langue = $null
    if (test-path $WinpeFile){
        # Dans le GUI, on lit le build sans monter l'image
	    $reader = New-Object System.IO.FileStream($WinpeFile, 'Open', 'Read', 'ReadWrite')
        if ($reader.Length -gt 2048){
	        [byte[]]$buffer = new-object byte[] 2048
	        $null = $reader.Seek(-2048, [System.IO.SeekOrigin]::End )
	        $count = $reader.Read($buffer, 0,2048)
	        $enc = [System.Text.Encoding]::unicode
	        $s = $enc.GetString($buffer)
   	        $build = [regex]::replace($s, '(.+)(<BUILD>)(\d+)(</BUILD>)(.+)', '$3')
            $name  = [regex]::replace($s, '(.+)(<NAME>)(.+)(</NAME>)(.+)', '$3')
        }
	    $null = $reader.Close()
    }
    if (Test-Path $RefFile){
        # Si la version de la ref est différente de celle de Winpe alors pb
        $e = gi $RefFile
        $v = $e.VersionInfo.ProductVersion # 10.0.10586.0
        #if (($v -split '\.')[2] -ne $build){
        #    $null=[system.windows.forms.messagebox]::Show("Les build de Winpe et de la reférence W10 sont différents.`r`nBuild Winpe $build`r`nBuild Ref Win : $v")
        #}

        # pour lire la langue de l'ISO de Référence, on charge la ruche system de la référence
        $Langues = $null
        try{
            # en cas d'erreur dans traitement, les ruches restent chargées. Donc on les décharge.
            "Tmp_System","Tmp_Software","Tmp_Defaut","src_System","src_Software","src_Defaut" | %{UnloadRuche $_}
            # si le fichier de la ruche de référence existe ...
            $PathSrcHiveRef = Join-Path $textBox_RefWindows.Text "Windows\system32\config\system"
            if (test-path $PathSrcHiveRef){
                # la ruche possède un nom différent dans le script traitement. On la décharge si besoin.
                UnloadRuche $NameSrcHiveRef
                LoadRuche $NameSrcHiveRef $PathSrcHiveRef
                #on lit la langue HKEY_USERS\tmp_ref_sys\ControlSet001\Control\MUI\UILanguages\
                $cleLangues = "HKU:\tmp_ref_sys\ControlSet001\Control\MUI\UILanguages"
                if (-not (test-path "$cleLangues`:" -ea SilentlyContinue) ) {
                    $hku = new-psdrive -Name HKU -Root HKEY_USERS -psprovider Registry
                }
                $Langues = gci $cleLangues -ea SilentlyContinue
                # Il y en a une seule généralement.
                # Mais il peut en exister plusieurs : comment savoir quelle est la bonne ?
                if ($Langues.count -gt 1){
                    # s'il y en a plusieurs, une seule contient DefaultFallback = en-us
                    $oLangue = $Langues | ?{ (Get-ItemPropertyValue $_.PSPath -Name DefaultFallback).Tolower() -eq "en-us"}
                    $langue = $oLangue.PSChildName
                }elseif($Langues.count -eq 1){
                    # bug Language in Avril 2017
                    # si cette propriété n'existe pas alors on valide en-us si elle est présente
                    $oLangue = $Langues
                    $langue = $oLangue.PSChildName
                }else{
                    # que faire ? 
                    throw "Erreur lors de la détection de la langue dans la référence."
                }
            }
        }
        catch{
            $langue = $null 
        }
        finally{
            # on libère les handles de PS
            $Langues|%{ if ($_.handle -ne $null) {$_.handle.close()} }
            UnloadRuche $NameSrcHiveRef
            Remove-PSDrive -Name HKU -ea SilentlyContinue
            [GC]::collect()
            [GC]::WaitForPendingFinalizers()
        } 
    }
    "$name Build: $build","Ref Build: $v", $langue
}
#region construction du runspace des traitements
function CreationDuRunspaceDesTraitements{
    $global:so.fileTraitement       = $fileTraitement
    $global:so.fileWifiConnexion    = $fileWifiConnexion
    $global:so.fileProductOptions   = $fileProductOptions
    $global:so.fileStateRepository1 = $fileStateRepository1
    $global:so.fileStateRepository2 = $fileStateRepository2
    $global:so.fileTerminalServer   = $fileTerminalServer
    $global:so.fileScreenResolution = $fileScreenResolution
    #$global:so.fileModifyTheme      = $fileModifyTheme
    #$global:so.fileSetWow64         = $fileSetWow64
    $global:so.fileNotificationsOobeComplete = $fileNotificationsOobeComplete

    #[system.windows.forms.messagebox]::Show("$fileTraitement`r`n$fileWifiConnexion`r`n$fileSetWow64`r`n$fileProductOptions`r`n$fileModifyTheme`r`n$fileScreenResolution")
    #[system.windows.forms.messagebox]::Show("$fileTraitement`r`n$fileWifiConnexion`r`n$fileProductOptions`r`n$fileScreenResolution`r`n$fileNotificationsOobeComplete")

    # charger le script dans un scriptblock
    $r = gc -path $fileTraitement | Out-String
    #$r = gc -path $traitement
    $global:newsb = [scriptblock]::Create( $r ) 
    # le mettre dans le runspace
    $global:newrs = [RunspaceFActory]::CreateRunSpace()
    $global:newrs.ApartmentState = "STA"
    $global:newrs.ThreadOptions = "ReuseThread"
    $global:newrs.Open()
    $global:newps = [Powershell]::Create()
    $global:newps.Runspace = ($global:newrs)
    # mettre la variable so dans le runspace
    $global:newps.Runspace.SessionStateProxy.SetVariable("So", ($global:so))
    #
    $handle = $global:newps.Addscript($global:newsb).BeginInvoke()
}
function DesctructionDuRunspaceDesTraitements{
    $global:newps.endinvoke()
    $global:newps.dispose()
    $global:newrs.close()
    $global:newrs.dispose()
    $global:ewhDebutDesTraitements.close()
    $global:ewhDebutDesTraitements.dispose()
}
#endregion construction du runspace des traitements
#region show/hide console PS
if (-not ("Console.Window" -as [Type]))
{
    Add-Type -Name Window -Namespace Console -MemberDefinition '
        [DllImport("Kernel32.dll")]
        public static extern IntPtr GetConsoleWindow();
 
        [DllImport("user32.dll")]
        public static extern bool ShowWindow(IntPtr hWnd, Int32 nCmdShow);

        [DllImport("kernel32.dll", SetLastError = true)]
        internal static extern int AllocConsole();

        [DllImport("kernel32.dll", SetLastError = true)]
        internal static extern int FreeConsole();

        [DllImport("kernel32", SetLastError = true)]
        static extern bool AttachConsole(uint dwProcessId);
'
}
function Show-Console {
    $consolePtr = [Console.Window]::GetConsoleWindow()
    #5 show
    [Console.Window]::ShowWindow($consolePtr, 5)
}
 
function Hide-Console {
    $consolePtr = [Console.Window]::GetConsoleWindow()
    #0 hide
    [Console.Window]::ShowWindow($consolePtr, 0)
}
#endregion show/hide console PS
#region execution
function execution_GenereBootWim{
    [System.Windows.Forms.MessageBox]::Show("execution_GenereBootWim")
}
function execution_Integration{
    [System.Windows.Forms.MessageBox]::Show("execution_Integration")
}
function execution
{
    $global:ewhDebutDesTraitements.set()
}
function saisieOK{
    (Test-Path $textBox_SrcAdk.Text) -and (Test-Path $textBox_RefWindows.Text) -and ($global:So.Langue -ne $null)
}
#endregion execution
#endregion fonctions

# help : http://blogs.technet.com/b/tonyh/archive/2011/10/25/manage-cloud-mailbox-folder-permissions-with-a-gui.aspx
#region texte
    $TextPresentation = "
    But : permettre de modifier une image boot.wim de Winpe en injectant les données collectées et mises en forme.

Deux utilisations possibles :

        - En l'état actuel des scripts, vous aurez à votre disposition les ajouts que j'ai intégrés.

        - Vous pouvez modifier les scripts, alimenter le pdf, pour, par exemple, ajouter vos découvertes.

Contrainte retenue : 
        Utiliser uniquement des programmes de l'ADK et de Windows

Restrictions :
        - Ce script est un outil 'pédagogique'. C'est un complément du PDF associé. 
        - Vous devrez modifier ce script pour ajouter vos souhaits 
        - Ce n'est pas un outil de production comme WinPeSe. 

Préparatifs nécessaires :
        - Avoir installé l'ADK contenant Winpe : c'est long !
        - Disposer d'un support (iso, install.wim, répertoire ) contenant les fichiers de Windows.
        - Utiliser un PC sous Windows 10
        	J'ai toujours utilisé la même version pour l'ADK, la référence et l'OS exécutant ce script
	-Créer un répertoire de base <base>
	-Créer <base>\AddRoot, cette arborescence sera recopiée dans 'mount'
	-Créer <base>\AddOem, qui contient tous les répertoires des drivers à ajouter

Très important : 
        C'est la langue définie par le support ISO qui sera utilisée dans Winpe.
        Le fuseau horaire est codé en dur dans le script

Le principe général :

    - Génération d'un fichier boot.wim initial :

    Ce script lance copype.cmd de l'ADK. L'arborescence créée contient le fichier 'Boot.wim'.
    Puis il ajoute tous les paquets proposés par l'ADK ( voir la liste dans le script ).
        Note :  Il est possible d'utiliser une arborescence déjà existante. Pour cela, il faut 
                recopier '...\media\sources\Boot.wim' en 'Boot.wim.AvecPaquetsDeBase.export'.
    Cette génération est faite une seule fois. Elle est longue.

    Ensuite, votre investigation au sein de Winpe vous amènera à découvrir des éléments à ajouter.
    Ces éléments vous permettront de disposer d'une fonctionnalité convoitée. Il seront injectés dans boot.wim.

    - Injection des modifications :

    Vous modifierez ce script pour qu'il prenne en compte les éléments que vous avez identifés.
    Chaque itération recopie le fichier initial 'Boot.wim.AvecPaquetsDeBase.export' en 'Boot.wim'.
    Le point de départ de votre construction est donc toujours le même fichier. Ceci garantit la
    reproductibilité de votre Winpe.

    Actuellement, cette étape dure plusieurs minutes.

Le sous-système Wow32 :

    L'intégration de ce sous-système est rudimentaire.
    Elle vise à montrer l'interaction avec des fonctionnalités de 'explorer' utilisant COM 64bits.
    Il n'est plus utile d'utiliser le script Ps pour créer les objects système ( tiré du source de setwow64.exe de WinPeSe ).
    Le logiciel 'Winobj.exe' 32 bits de 'technet/sysinternals' permet de visualiser les objets 'système' créés.

    Utiliser WinPeSe pour une mise en oeuvre complète de ce sous-système.

Présentation succincte du fonctionnement du script:

    L'onglet 'saisie' permet de définir les divers chemins utiles :
        - le répertoire de base du projet : 
            il sera créé par le script 'copype.cmd' de l'ADK lancé automatiquement
        - le répertoire contenant l'ADK : 
            il sera détecté automatiquement si l'ADK est correctement installé
        - le répertoire contenant les fichiers décompressés de 'install.wim' :
            actuellement, il faut préparer soi-même ce répertoire.

    Le bouton 'enregistrement' permet de mémoriser ces données dans un fichier associé au script.
    Dans le cas normal, ce fichier est un flux alternatif. Mais si ce script est lancé avec l'option
    '-debug true' alors ce fichier est un fichier ordinaire.
    
    L'onglet 'configuration' permet de définir actuellement 2 options :
        - la source utilisée pour la ruche software, celle de winpe ou celle de install.wim. 
		TODO : Supprimer ce choix
        - l'outil utilisé pour charger/décharger les ruches, reg.exe ou les API de C#.

    Lors des saisies, on recherche les informations suivantes :
        - les builds de Winpe et de l'ISO de référence
        - la langue contenue dans l'ISO de référence ( chargement/déchargement de la ruche software )

    Si ces informations sont cohérentes alors le bouton 'Build' devient actif.

    Une console permettra de visualiser le retour des commandes lancées.
    Le pourcentage de progression de Dism.exe est affiché dans la barre d'état.

    Un fichier de log ( lastlog.txt ) est généré à chaque fin de lancement de tâches. Pas d'historique.

    Un mode débug est activé avec le paramètre de ligne de comande '-debug true' : 
        utile en cas de modification du script pour voir les erreurs.

    Performances et robustesse : limitées !

Les différents fichiers utilisés par ce script:

    Ils doivent se situer dans le même répertoire.

Ajout manuel de fichiers : TODO!

    Vous pouvez ajouter des fichiers dans le répertoire de base. Puis modifier le script.
    Rechercher winobj.exe dans le script pour disposer d'un exemple.

Ce que lance le script :

    copype.cmd de l'ADK si besoin
    dism.exe pour installer les paquets de l'ADK et les pilotes
    reg.exe export ( load et unload )
    regedit.exe pour modifier les ruches de l'image Boot.wim

Anomalies constatées : 

    erreur 'élément introuvable' : le répertoire de référence associé au 'montage' du fichier install.wim contient bien des fichiers 
                                    mais certains de ces fichiers ne peuvent pas etre ouverts ou copiés. 
                                       Seule solution : démonter et remonter cette référence.
    erreur 'REG UNLOAD'          : survient parfois dans le cas de 'catch'
    erreur 'explorer ouvert'     : une messagebox s'affiche en arrière plan, donc peu visible.

Le site de référence : http://theoven.org
    A consulter obligatoirement.
    Utilisez WinPeSe pour obtenir un outil de qualité, efficace et complet.
"
 
    $label_HelpSaveConfigText = "
Les saisies seront mémorisées dans le fichier $NomDuFichierDeConfig'. 

Ce fichier est un flux alternatif associé à ce script.
Il est écrasé si vous modifiez le script avec powershell_ise par exemple.
Il peut être édité si besoin avec notepad depuis une console :

notepad <pathScript>:<name>
avec <name> = $NomDuFichierDeConfig
"
#endregion texte

#region eventHandler    
    $OnLoadForm_StateCorrection =
    {#Correct the initial state of the form to prevent the .Net maximized form issue
	    $form1.WindowState = $InitialFormWindowState
    }

    # on affiche la boîte de sélection de répertoire pour la racine
    $button_SaisieRacine_OnClick=
    {
        $browse = New-Object System.Windows.Forms.FolderBrowserDialog
        $browse.RootFolder = [System.Environment+SpecialFolder]'MyComputer'
        #$browse.RootFolder = [System.Environment+SpecialFolder]::MyDocuments
        $browse.ShowNewFolderButton = $true
        $browse.Description = "Sélectionner ou créer votre répertoire <racine>"

        if ($browse.ShowDialog() -eq "OK"){
            $textBox_Racine.Text = $browse.SelectedPath
        }
        $browse.Dispose()
    }

    # on affiche la boîte de sélection de répertoire pour l'ADK
    $button_SaisieAdk_OnClick=
    {
        $browse = New-Object System.Windows.Forms.FolderBrowserDialog
        $browse.RootFolder = [System.Environment+SpecialFolder]'MyComputer'
        #$browse.RootFolder = [System.Environment+SpecialFolder]::ProgramFilesX86
        $browse.ShowNewFolderButton = $false
        $browse.Description = "Sélectionner le répertoire de l'ADK"

        if ($browse.ShowDialog() -eq "OK"){
            $textBox_SrcAdk.Text = $browse.SelectedPath
        }
        $browse.Dispose()
    }

    # on affiche la boîte de sélection de répertoire pour la référence
    $button_SaisieRef_OnClick=
    {
        $browse = New-Object System.Windows.Forms.FolderBrowserDialog
        #$browse.RootFolder = [System.Environment+SpecialFolder]'MyComputer'
        $browse.RootFolder = [System.Environment+SpecialFolder]::MyComputer
        $browse.ShowNewFolderButton = $true
        $browse.Description = "Sélectionner le répertoire contenant les fichiers d'une image de Windows"

        if ($browse.ShowDialog() -eq "OK"){
            $textBox_RefWindows.Text = $browse.SelectedPath
        }
        $browse.Dispose()
    }

    # on sauvegarde les info
    $button_SaveInfo_OnClick=
    {
        ecrire-config $textBox_Racine.Text $textBox_SrcAdk.Text  $textBox_RefWindows.Text
    }

    # on lance le traitement
    $button_Excution_OnClick=
    {
        # test des saisies
        if (saisieOK){
            # activer l'onglet console : attention en cas de modif du nombre d'onglets !!!
            $tabControl1.SelectedIndex = 3
            # anomalie avec $tabControl1.SelectedTab = "tabPage_Console"
            # bloquer les onglets.
            $tabControl1.Enabled = $false
            # vider la console 
            $textBox_Console.Text = "$(get-date) Début des traitements."
            # bloquer le bouton execution
            $button_Excution.Enabled = $false;

            # mise à jour SO
            $global:so.Racine = ($textBox_Racine.Text).TrimEnd("\")
            $global:so.SrcAdk = ($textBox_SrcAdk.Text).TrimEnd("\")
            $global:so.RefWindows = ($textBox_RefWindows.Text).TrimEnd("\")
            #conf du script
            if ($bLoadUnloadRegExe.checked){
                $global:so.LoadUnloadRegExe=$true
            }else{
                $global:so.LoadUnloadRegExe=$false
            }
            if ($bFullSoftware.checked){
                $global:so.full_SrcSoftware=$true
            }else{
                $global:so.full_SrcSoftware=$false
            }
            if ($radioButton_SessionAdmin_Auto.checked){
                $global:so.SessionAdmin_Auto=$true
            }else{
                $global:so.SessionAdmin_Auto=$false
            } 
            if ($radioButton_traceEnable.checked){
                $global:so.NetworkTrace=$true
            }else{
                $global:so.NetworkTrace=$false
            } radioButton_traceEnable

            # pour lancer tous les traitements sans bloquer l'ihm on utilise un event qui débloque un runspace
            execution
            
        }else{
            $tabcontrol1.SelectedIndex = 1
        }
    }
    # l'action du bouton est automatisée en cas de modification des 2 textbox
    $button_GetInfoWim_OnClick=
    {
        if ($textBox_Racine.Text -ne "" -and $textBox_RefWindows.Text -ne "") {
            $WinpeFile      = join-path $textBox_Racine.Text "build\media\sources\boot.wim"
            $RefFile        = Join-Path $textBox_RefWindows.Text "Windows\explorer.exe"
            $toolStripStatusLabel_Builds.Text, $toolStripStatusLabel_BuildRef.Text, $toolStripStatusLabel_langue.Text = GetInfoWim $WinpeFile $RefFile 
            $global:So.Langue = $toolStripStatusLabel_langue.Text
            if ($toolStripStatusLabel_langue.Text -eq $null -or $toolStripStatusLabel_langue.Text -eq "") {
                $toolStripStatusLabel_langue.Text = "Langue ???"
                $button_Excution.Enabled = $false
            }else{
                $button_Excution.Enabled = $true
            }
        }
    }
    $textBox_RefWindows_TextChanged={
        #[System.Windows.Forms.MessageBox]::Show("textBox_RefWindows_TextChanged")
        & $button_GetInfoWim_OnClick
    }
    $textBox_Racine_TextChanged={
        & $button_GetInfoWim_OnClick
    }
    # on ferme le script
    $button_Exit_OnClick=
    {
        #DesctructionDuRunspaceDesTraitements
        $form1.Close()
    }
    # pas utile pour l'instant
    $form1_keyControle={
        #InvalideBoutons
        #ActiveBoutons
    }

#endregion eventHandler 

# pour masquer la console d'origine : 
if (!$Debug){Hide-Console}

#region DeclarationDesVariables
    $form1 = New-Object System.Windows.Forms.Form
    $tabControl1 = New-Object System.Windows.Forms.TabControl
    $tabPage_Presentation = New-Object System.Windows.Forms.TabPage
    $textBox4 = New-Object System.Windows.Forms.TextBox
    $tabPage_Saisie = New-Object System.Windows.Forms.TabPage
    $groupBox4 = New-Object System.Windows.Forms.GroupBox
    $label_HelpSaveConfig = New-Object System.Windows.Forms.Label
    $button_SaveInfo = New-Object System.Windows.Forms.Button
    $groupBox3 = New-Object System.Windows.Forms.GroupBox
    $button_SaisieRef = New-Object System.Windows.Forms.Button
    $textBox_RefWindows = New-Object System.Windows.Forms.TextBox
    $groupBox2 = New-Object System.Windows.Forms.GroupBox
    $button_SaisieAdk = New-Object System.Windows.Forms.Button
    $textBox_SrcAdk = New-Object System.Windows.Forms.TextBox
    $groupBox1 = New-Object System.Windows.Forms.GroupBox
    $button_SaisieRacine = New-Object System.Windows.Forms.Button
    $textBox_Racine = New-Object System.Windows.Forms.TextBox
    $tabPage_Configuration = New-Object System.Windows.Forms.TabPage
    $label1 = New-Object System.Windows.Forms.Label
    $tabPage_Console = New-Object System.Windows.Forms.TabPage
    $textBox_Console = New-Object System.Windows.Forms.TextBox
    $button_Exit = New-Object System.Windows.Forms.Button
    $button_GetInfoWim = New-Object System.Windows.Forms.Button
    $statusStrip1 = New-Object System.Windows.Forms.StatusStrip
    $toolStripStatusLabel_Date = New-Object System.Windows.Forms.ToolStripStatusLabel
    $toolStripStatusLabel_Builds = New-Object System.Windows.Forms.ToolStripStatusLabel
    $toolStripStatusLabel_BuildRef = New-Object System.Windows.Forms.ToolStripStatusLabel
    $toolStripStatusLabel_Dism = New-Object System.Windows.Forms.ToolStripStatusLabel
    $toolStripStatusLabel_Langue = New-Object System.Windows.Forms.ToolStripStatusLabel
    $button_Excution = New-Object System.Windows.Forms.Button
    $radioButton1 = New-Object System.Windows.Forms.RadioButton
    $radioButton2 = New-Object System.Windows.Forms.RadioButton
    $radioButton3 = New-Object System.Windows.Forms.RadioButton
    $groupBox5 = New-Object System.Windows.Forms.GroupBox
    #configuration du script
    $groupBox7 = New-Object System.Windows.Forms.GroupBox
    $bLoadUnloadApi = New-Object System.Windows.Forms.RadioButton
    $bLoadUnloadRegExe = New-Object System.Windows.Forms.RadioButton
    $groupBox6 = New-Object System.Windows.Forms.GroupBox
    $bFullSoftware = New-Object System.Windows.Forms.RadioButton
    $bPartialSoftware = New-Object System.Windows.Forms.RadioButton
    $groupBox8 = New-Object System.Windows.Forms.GroupBox
    $radioButton_SessionAdmin_Manual = New-Object System.Windows.Forms.RadioButton 
    $radioButton_SessionAdmin_Auto   = New-Object System.Windows.Forms.RadioButton
    $groupBox9 = New-Object System.Windows.Forms.GroupBox
    $radioButton_TraceDisable = New-Object System.Windows.Forms.RadioButton 
    $radioButton_traceEnable  = New-Object System.Windows.Forms.RadioButton 



    $InitialFormWindowState = New-Object System.Windows.Forms.FormWindowState
#endregion DeclarationDesVariables

#region SuspendLayout
    $tabControl1.SuspendLayout();
    $tabPage_Presentation.SuspendLayout();
    $tabPage_Saisie.SuspendLayout();
    $groupBox4.SuspendLayout();
    $groupBox3.SuspendLayout();
    $groupBox2.SuspendLayout();
    $groupBox1.SuspendLayout();
    $tabPage_Configuration.SuspendLayout();
    $tabPage_Console.SuspendLayout();
    $statusStrip1.SuspendLayout();
    $groupBox5.SuspendLayout();
    $groupBox6.SuspendLayout();
    $groupBox7.SuspendLayout();
    $groupBox8.SuspendLayout();
    $groupBox9.SuspendLayout();

    $form1.SuspendLayout();
#endregion SuspendLayout

#region the controls
    # 
    # tabControl1
    # 
    $tabControl1.Controls.Add($tabPage_Presentation);
    $tabControl1.Controls.Add($tabPage_Saisie);
    $tabControl1.Controls.Add($tabPage_Configuration);
    $tabControl1.Controls.Add($tabPage_Console);
    $tabControl1.Location = New-Object System.Drawing.Point(35, 12);
    $tabControl1.Name = "tabControl1";
    $tabControl1.SelectedIndex = 0;
    $tabControl1.Size = New-Object System.Drawing.Size(796, 373);
    $tabControl1.TabIndex = 1;
    $tabControl1.Anchor = "Top,Bottom,Left,Right"  # ajout sezz
    # 
    # tabPage_Presentation
    # 
    $tabPage_Presentation.Controls.Add($textBox4);
    $tabPage_Presentation.Location = New-Object System.Drawing.Point(4, 22);
    $tabPage_Presentation.Name = "tabPage_Presentation";
    $tabPage_Presentation.Padding = New-Object System.Windows.Forms.Padding(3);
    $tabPage_Presentation.Size = New-Object System.Drawing.Size(788, 347);
    $tabPage_Presentation.TabIndex = 4;
    $tabPage_Presentation.Text = "Présentation";
    $tabPage_Presentation.UseVisualStyleBackColor = $true;
    # 
    # textBox4
    # 
    $textBox4.AcceptsReturn = $true;
    $textBox4.AcceptsTab = $true;
    $textBox4.Location = New-Object System.Drawing.Point(6, 3);
    $textBox4.Multiline = $true;
    $textBox4.Name = "textBox4";
    $textBox4.ReadOnly = $true;
    $textBox4.ScrollBars = [System.Windows.Forms.ScrollBars]::Vertical;
    $textBox4.Size = New-Object System.Drawing.Size(776, 338);
    $textBox4.TabIndex = 0;
    $textBox4.TabStop = $false;
    #$textBox4.Text = resources.GetString("textBox4.Text");
    $textBox4.Text = $TextPresentation;
    $textBox4.Anchor = "Top,Left,Bottom,Right";   #ajout sezz
    # 
    # tabPage_Saisie
    # 
    $tabPage_Saisie.Controls.Add($groupBox4);
    $tabPage_Saisie.Controls.Add($groupBox3);
    $tabPage_Saisie.Controls.Add($groupBox2);
    $tabPage_Saisie.Controls.Add($groupBox1);
    $tabPage_Saisie.Location = New-Object System.Drawing.Point(4, 22);
    $tabPage_Saisie.Name = "tabPage_Saisie";
    $tabPage_Saisie.Padding = New-Object System.Windows.Forms.Padding(3);
    $tabPage_Saisie.Size = New-Object System.Drawing.Size(788, 347);
    $tabPage_Saisie.TabIndex = 0;
    $tabPage_Saisie.Text = "Saisie des chemins";
    $tabPage_Saisie.UseVisualStyleBackColor = $true;
    # 
    # groupBox4
    # 
    $groupBox4.Controls.Add($label_HelpSaveConfig);
    $groupBox4.Controls.Add($button_SaveInfo);
    $groupBox4.Location = New-Object System.Drawing.Point(528, 31);
    $groupBox4.Name = "groupBox4";
    $groupBox4.Size = New-Object System.Drawing.Size(225, 295);
    $groupBox4.TabIndex = 13;
    $groupBox4.TabStop = $false;
    $groupBox4.Text = "Enregistrement des saisies";
    $groupBox4.Anchor = "Top,Bottom,Left,Right"                  #ajout ancrage
    # 
    # label_HelpSaveConfig
    # 
    $label_HelpSaveConfig.Location = New-Object System.Drawing.Point(6, 20);
    $label_HelpSaveConfig.Name = "label_HelpSaveConfig";
    $label_HelpSaveConfig.Size = New-Object System.Drawing.Size(215, 172);
    $label_HelpSaveConfig.TabIndex = 12;
    #$label_HelpSaveConfig.Text = resources.GetString("label_HelpSaveConfig.Text");
    $label_HelpSaveConfig.Text = $label_HelpSaveConfigText
    $label_HelpSaveConfig.Anchor = "Top,Left,Bottom,Right"        #ajout ancrage
    # 
    # button_SaveInfo
    # 
    $button_SaveInfo.Location = New-Object System.Drawing.Point(18, 214);
    $button_SaveInfo.Name = "button_SaveInfo";
    $button_SaveInfo.Size = New-Object System.Drawing.Size(189, 35);
    $button_SaveInfo.TabIndex = 7;
    $button_SaveInfo.Text = "Enregistrement des informations saisies";
    $button_SaveInfo.UseVisualStyleBackColor = $true;
    $button_SaveInfo.Anchor = "Bottom,Left,Right"            #ajout ancrage
    #$button_SaveInfo.Click += New-Object System.EventHandler($button_SaveInfo_Click);
    $button_SaveInfo.Add_Click($button_SaveInfo_OnClick);
    # 
    # groupBox3
    # 
    $groupBox3.Controls.Add($groupBox5);
    $groupBox3.Controls.Add($button_SaisieRef);
    $groupBox3.Controls.Add($textBox_RefWindows);
    $groupBox3.Location = New-Object System.Drawing.Point(31, 215);
    $groupBox3.Name = "groupBox3";
    $groupBox3.Size = New-Object System.Drawing.Size(455, 111);
    $groupBox3.TabIndex = 11;
    $groupBox3.TabStop = $false;
    $groupBox3.Text = "Répertoire contenant les fichiers de référence de Windows10";
    # 
    # button_SaisieRef
    # 
    $button_SaisieRef.Location = New-Object System.Drawing.Point(373, 73);
    $button_SaisieRef.Name = "button_SaisieRef";
    $button_SaisieRef.Size = New-Object System.Drawing.Size(59, 20);
    $button_SaisieRef.TabIndex = 6;
    $button_SaisieRef.Text = "browse...";
    $button_SaisieRef.UseVisualStyleBackColor = $true;
    #$button_SaisieRef.Click += New-Object System.EventHandler($button_SaisieRef_Click);
    $button_SaisieRef.add_Click($button_SaisieRef_OnClick);
    # 
    # textBox3
    # 
    $textBox_RefWindows.Location = New-Object System.Drawing.Point(17, 74);
    $textBox_RefWindows.Name = "textBox3";
    $textBox_RefWindows.Size = New-Object System.Drawing.Size(341, 20);
    $textBox_RefWindows.TabIndex = 5;
    $textBox_RefWindows.Text = "textBox3";
    # 
    # groupBox2
    # 
    $groupBox2.Controls.Add($button_SaisieAdk);
    $groupBox2.Controls.Add($textBox_SrcAdk);
    $groupBox2.Location = New-Object System.Drawing.Point(31, 119);
    $groupBox2.Name = "groupBox2";
    $groupBox2.Size = New-Object System.Drawing.Size(455, 81);
    $groupBox2.TabIndex = 10;
    $groupBox2.TabStop = $false;
    $groupBox2.Text = "Répertoire contenant l'ADK de Windows10";
    # 
    # button_SaisieAdk
    # 
    $button_SaisieAdk.Location = New-Object System.Drawing.Point(373, 29);
    $button_SaisieAdk.Name = "button_SaisieAdk";
    $button_SaisieAdk.Size = New-Object System.Drawing.Size(59, 20);
    $button_SaisieAdk.TabIndex = 4;
    $button_SaisieAdk.Text = "browse...";
    $button_SaisieAdk.UseVisualStyleBackColor = $true;
    #$button_SaisieAdk.Click += New-Object System.EventHandler($button_SaisieAdk_Click);
    $button_SaisieAdk.add_Click($button_SaisieAdk_OnClick)
    # 
    # textBox2
    # 
    $textBox_SrcAdk.Location = New-Object System.Drawing.Point(17, 29);
    $textBox_SrcAdk.Name = "textBox2";
    $textBox_SrcAdk.Size = New-Object System.Drawing.Size(341, 20);
    $textBox_SrcAdk.TabIndex = 3;
    $textBox_SrcAdk.Text = "textBox2";
    # 
    # groupBox1
    # 
    $groupBox1.Controls.Add($button_SaisieRacine);
    $groupBox1.Controls.Add($textBox_Racine);
    $groupBox1.Location = New-Object System.Drawing.Point(31, 23);
    $groupBox1.Name = "groupBox1";
    $groupBox1.Size = New-Object System.Drawing.Size(455, 81);
    $groupBox1.TabIndex = 9;
    $groupBox1.TabStop = $false;
    $groupBox1.Text = "Racine de la destination du projet";
    # 
    # button_SaisieRacine
    # 
    $button_SaisieRacine.Location = New-Object System.Drawing.Point(373, 28);
    $button_SaisieRacine.Name = "button_SaisieRacine";
    $button_SaisieRacine.Size = New-Object System.Drawing.Size(59, 20);
    $button_SaisieRacine.TabIndex = 2;
    $button_SaisieRacine.Text = "browse...";
    $button_SaisieRacine.UseVisualStyleBackColor = $true;
    #$button_SaisieRacine.Click += New-Object System.EventHandler($button_SaisieRacine_Click);
    $button_SaisieRacine.add_Click($button_SaisieRacine_OnClick);
    # 
    # textBox1
    # 
    $textBox_Racine.Location = New-Object System.Drawing.Point(17, 28);
    $textBox_Racine.Name = "textBox1";
    $textBox_Racine.Size = New-Object System.Drawing.Size(341, 20);
    $textBox_Racine.TabIndex = 1;
    $textBox_Racine.Text = "textBox1";
    # 
    # tabPage_Configuration
    # 
    $tabPage_Configuration.Controls.Add($groupBox7);
    $tabPage_Configuration.Controls.Add($groupBox6);
    $tabPage_Configuration.Controls.Add($groupBox8);
    $tabPage_Configuration.Controls.Add($groupBox9);
    $tabPage_Configuration.Controls.Add($label1);
    $tabPage_Configuration.Location = New-Object System.Drawing.Point(4, 22);
    $tabPage_Configuration.Name = "tabPage_Configuration";
    $tabPage_Configuration.Padding = New-Object System.Windows.Forms.Padding(3);
    $tabPage_Configuration.Size = New-Object System.Drawing.Size(788, 347);
    $tabPage_Configuration.TabIndex = 3;
    $tabPage_Configuration.Text = "Configuration du script";
    $tabPage_Configuration.UseVisualStyleBackColor = $true;
    # 
    # label1
    # 
    $label1.AutoSize = $false; #$true;
    $label1.Location = New-Object System.Drawing.Point(294,28) #(338, 158);
    $label1.Name = "label1";
    $label1.Size = New-Object System.Drawing.Size(465, 267) #(73, 13);
    $label1.TabIndex = 0;
    $label1.Text = "En chantier ...";
    # 
    # tabPage_Console
    # 
    $tabPage_Console.Controls.Add($textBox_Console);
    $tabPage_Console.Location = New-Object System.Drawing.Point(4, 22);
    $tabPage_Console.Name = "tabPage_Console";
    $tabPage_Console.Size = New-Object System.Drawing.Size(788, 347);
    $tabPage_Console.TabIndex = 5;
    $tabPage_Console.Text = "Console";
    $tabPage_Console.UseVisualStyleBackColor = $true;
    # 
    # textBox5
    # 
    $textBox_Console.AcceptsReturn = $true;
    $textBox_Console.AcceptsTab = $true;
    $textBox_Console.Location = New-Object System.Drawing.Point(3, 15);
    $textBox_Console.Multiline = $true;
    $textBox_Console.Name = "textBox5";
    $textBox_Console.ReadOnly = $true;
    $textBox_Console.ScrollBars = [System.Windows.Forms.ScrollBars]::Vertical;
    $textBox_Console.Size = New-Object System.Drawing.Size(782, 329);
    $textBox_Console.Anchor = "Top,Left,Bottom,Right";                        # ajout sezz
	$textBox_Console.Font = New-Object System.Drawing.Font("Consolas", 8);    # ajout sezz
    $textBox_Console.TabIndex = 0;
    # 
    # button_Exit
    # 
    $button_Exit.Location = New-Object System.Drawing.Point(744, 415);
    $button_Exit.Name = "button_Exit";
    $button_Exit.Size = New-Object System.Drawing.Size(80, 25);
    $button_Exit.TabIndex = 9;
    $button_Exit.Text = "Exit";
    $button_Exit.UseVisualStyleBackColor = $true;
    #$button_Exit.Click += New-Object System.EventHandler($button_Exit_Click);
    $button_Exit.Add_Click($button_Exit_OnClick);
    $button_Exit.Anchor = "Bottom,Right";
    # 
    # statusStrip1
    # 
    $statusStrip1.Items.AddRange( ([System.Windows.Forms.ToolStripItem[]](
        $toolStripStatusLabel_Date,
        $toolStripStatusLabel_Builds,
        $toolStripStatusLabel_BuildRef,
        $toolStripStatusLabel_langue,
        $toolStripStatusLabel_Dism))
    );
    $statusStrip1.Location = New-Object System.Drawing.Point(0, 474);
    $statusStrip1.Name = "statusStrip1";
    $statusStrip1.Size = New-Object System.Drawing.Size(867, 22);
    $statusStrip1.TabIndex = 10;
    $statusStrip1.Text = "statusStrip1";
    # 
    # toolStripStatusLabel_Date
    # 
    $toolStripStatusLabel_Date.BackColor = [System.Drawing.Color]::Lime;
    $toolStripStatusLabel_Date.Name = "toolStripStatusLabel_Date";
    $toolStripStatusLabel_Date.AutoSize = $false
    $toolStripStatusLabel_Date.Size = New-Object System.Drawing.Size(230, 17);
    $toolStripStatusLabel_Date.Text = "date/heure : ";
    # 
    # toolStripStatusLabel_Builds
    # 
    $toolStripStatusLabel_Builds.BackColor = [System.Drawing.Color]::Yellow;
    $toolStripStatusLabel_Builds.Name = "toolStripStatusLabel_Builds";
    $toolStripStatusLabel_Builds.AutoSize = $false
    $toolStripStatusLabel_Builds.Size = New-Object System.Drawing.Size(270, 17);
    $toolStripStatusLabel_Builds.Text = "Build Winpe : ?";
    #
    #toolStripStatusLabel_BuildRef
    #
    $toolStripStatusLabel_BuildRef.BackColor = [System.Drawing.Color]::Orange;
    $toolStripStatusLabel_BuildRef.Name = "toolStripStatusLabel_BuildRef";
    $toolStripStatusLabel_BuildRef.AutoSize = $false
    $toolStripStatusLabel_BuildRef.Size = New-Object System.Drawing.Size(140, 17);
    $toolStripStatusLabel_BuildRef.Text = "Build Ref : ?";
    # 
    # toolStripStatusLabel_langue
    # 
    $toolStripStatusLabel_langue.BackColor = [System.Drawing.SystemColors]::MenuHighlight;
    $toolStripStatusLabel_langue.Name = "toolStripStatusLabel_langue";
    $toolStripStatusLabel_langue.AutoSize = $false;
    $toolStripStatusLabel_langue.Size = New-Object System.Drawing.Size(120, 17);
    $toolStripStatusLabel_langue.Text = "Langue";
    # 
    # toolStripStatusLabel_Dism
    # 
    #$toolStripStatusLabel_Dism.BackColor = System.Drawing.Color.FromArgb(((int)(((byte)(255)))), ((int)(((byte)(128)))), ((int)(((byte)(255)))));
    $toolStripStatusLabel_Dism.BackColor = [System.Drawing.Color]::FromArgb(([int](([byte](255)))), ([int](([byte](128)))), ([int](([byte](255)))));
    $toolStripStatusLabel_Dism.Name = "toolStripStatusLabel_Dism";
    $toolStripStatusLabel_Dism.AutoSize = $false
    $toolStripStatusLabel_Dism.Size = New-Object System.Drawing.Size(90, 17);
    $toolStripStatusLabel_Dism.Text = "Dism :";
    # 
    # button_Excution
    # 
    $button_Excution.Location = New-Object System.Drawing.Point(296, 408);
    $button_Excution.Name = "button_Excution";
    $button_Excution.Size = New-Object System.Drawing.Size(284, 31);
    $button_Excution.TabIndex = 50;
    $button_Excution.Text = "Build";
    $button_Excution.UseVisualStyleBackColor = $true;
    $button_Excution.Enabled = $false
    #$button_Excution.Click += New-Object System.EventHandler($button_Excution_Click);
    $button_Excution.Add_Click($button_Excution_OnClick);
    $button_Excution.Anchor = "Left,Bottom,Right";           # ajout sezz
    # 
    # button_GetInfoWim : inutilisé actuellement, c'est devenu automatique
    # 
    $button_GetInfoWim.Location = New-Object System.Drawing.Point(100, 415);
    $button_GetInfoWim.Name = "button_GetInfoWim";
    $button_GetInfoWim.Size = New-Object System.Drawing.Size(80, 25);
    $button_GetInfoWim.TabIndex = 9;
    $button_GetInfoWim.Text = "GetInfoWim";
    $button_GetInfoWim.UseVisualStyleBackColor = $true;
    #$button_Exit.Click += New-Object System.EventHandler($button_Exit_Click);
    $button_GetInfoWim.Add_Click($button_GetInfoWim_OnClick);
    $button_GetInfoWim.Anchor = "Left,Bottom";;           # ajout sezz

    # 
    # radioButton1
    # 
    $radioButton1.AutoSize = $true;
    $radioButton1.Enabled = $false;
    $radioButton1.Location = New-Object System.Drawing.Point(22, 19);
    $radioButton1.Name = "radioButton1";
    $radioButton1.Size = New-Object System.Drawing.Size(39, 17);
    $radioButton1.TabIndex = 7;
    $radioButton1.Text = "Iso";
    $radioButton1.UseVisualStyleBackColor = $true;
    # 
    # radioButton2
    # 
    $radioButton2.AutoSize = $true;
    $radioButton2.Enabled = $false;
    $radioButton2.Location = New-Object System.Drawing.Point(132, 19);
    $radioButton2.Name = "radioButton2";
    $radioButton2.Size = New-Object System.Drawing.Size(76, 17);
    $radioButton2.TabIndex = 8;
    $radioButton2.Text = "Install.Wim";
    $radioButton2.UseVisualStyleBackColor = $true;
    # 
    # radioButton3
    # 
    $radioButton3.AutoSize = $true;
    $radioButton3.Checked = $true;
    $radioButton3.Location = New-Object System.Drawing.Point(241, 19);
    $radioButton3.Name = "radioButton3";
    $radioButton3.Size = New-Object System.Drawing.Size(74, 17);
    $radioButton3.TabIndex = 9;
    $radioButton3.TabStop = $true;
    $radioButton3.Text = "Répertoire";
    $radioButton3.UseVisualStyleBackColor = $true;
    # 
    # groupBox5
    # 
    $groupBox5.Controls.Add($radioButton3);
    $groupBox5.Controls.Add($radioButton2);
    $groupBox5.Controls.Add($radioButton1);
    $groupBox5.Location = New-Object System.Drawing.Point(17, 19);
    $groupBox5.Name = "groupBox5";
    $groupBox5.Size = New-Object System.Drawing.Size(344, 49);
    $groupBox5.TabIndex = 10;
    $groupBox5.TabStop = $false;
    $groupBox5.Text = "Type de support";
    # 
    # bPartialSoftware
    # 
    $bPartialSoftware.AutoSize = $true;
    #$bPartialSoftware.Checked = $true;
    $bPartialSoftware.Location = New-Object System.Drawing.Point(20, 34);
    $bPartialSoftware.Name = "bPartialSoftware";
    $bPartialSoftware.Size = New-Object System.Drawing.Size(56, 17);
    $bPartialSoftware.TabIndex = 1;
    $bPartialSoftware.TabStop = $true;
    $bPartialSoftware.Text = "Winpe";
    $bPartialSoftware.UseVisualStyleBackColor = $true;
    # 
    # bFullSoftware
    # 
    $bFullSoftware.AutoSize = $true;
    $bFullSoftware.Checked = $true;
    $bFullSoftware.Location = New-Object System.Drawing.Point(20, 57);
    $bFullSoftware.Name = "bFullSoftware";
    $bFullSoftware.Size = New-Object System.Drawing.Size(73, 17);
    $bFullSoftware.TabIndex = 2;
    $bFullSoftware.Text = "Install.wim";
    $bFullSoftware.UseVisualStyleBackColor = $true;
    # 
    # groupBox6
    # 
    $groupBox6.Controls.Add($bFullSoftware);
    $groupBox6.Controls.Add($bPartialSoftware);
    $groupBox6.Location = New-Object System.Drawing.Point(26, 28);
    $groupBox6.Name = "groupBox6";
    $groupBox6.Size = New-Object System.Drawing.Size(185, 100);
    $groupBox6.TabIndex = 3;
    $groupBox6.TabStop = $false;
    $groupBox6.Text = "Source de la ruche Software";
    # 
    # bLoadUnloadApi
    # 
    $bLoadUnloadApi.AutoSize = $true;
    $bLoadUnloadApi.Checked = $true;
    $bLoadUnloadApi.Location = New-Object System.Drawing.Point(20, 57);
    $bLoadUnloadApi.Name = "bLoadUnloadApi";
    $bLoadUnloadApi.Size = New-Object System.Drawing.Size(56, 17);
    $bLoadUnloadApi.TabIndex = 2;
    $bLoadUnloadApi.Text = "Api c#";
    $bLoadUnloadApi.UseVisualStyleBackColor = $true;
    #
    # bLoadUnloadRegExe
    # 
    $bLoadUnloadRegExe.AutoSize = $true;
    $bLoadUnloadRegExe.Location = New-Object System.Drawing.Point(20, 34);
    $bLoadUnloadRegExe.Name = "bLoadUnloadRegExe";
    $bLoadUnloadRegExe.Size = New-Object System.Drawing.Size(65, 17);
    $bLoadUnloadRegExe.TabIndex = 1;
    $bLoadUnloadRegExe.TabStop = $true;
    $bLoadUnloadRegExe.Text = "Reg.exe";
    $bLoadUnloadRegExe.UseVisualStyleBackColor = $true;
    # 
    # groupBox7
    # 
    $groupBox7.Controls.Add($bLoadUnloadApi);
    $groupBox7.Controls.Add($bLoadUnloadRegExe);
    $groupBox7.Location = New-Object System.Drawing.Point(26, 195);
    $groupBox7.Name = "groupBox7";
    $groupBox7.Size = New-Object System.Drawing.Size(185, 100);
    $groupBox7.TabIndex = 4;
    $groupBox7.TabStop = $false;
    $groupBox7.Text = "Load/Unload Hive";

    # 
    # groupBox_NetworkTrace
    # 
    $groupBox8.Controls.Add($radioButton_TraceDisable);
    $groupBox8.Controls.Add($radioButton_traceEnable);
    $groupBox8.Location = New-Object System.Drawing.Point(574, 195);
    $groupBox8.Name = "groupBox_NetworkTrace";
    $groupBox8.Size = New-Object System.Drawing.Size(185, 100);
    $groupBox8.TabIndex = 5;
    $groupBox8.TabStop = $false;
    $groupBox8.Text = "Network Trace";
    # 
    # radioButton_TraceDisable
    # 
    $radioButton_TraceDisable.AutoSize = $true;
    $radioButton_TraceDisable.Location = New-Object System.Drawing.Point(20, 57);
    $radioButton_TraceDisable.Name = "radioButton_TraceDisable";
    $radioButton_TraceDisable.Size = New-Object System.Drawing.Size(60, 17);
    $radioButton_TraceDisable.TabIndex = 2;
    $radioButton_TraceDisable.Text = "Disable";
    $radioButton_TraceDisable.UseVisualStyleBackColor = $true;
    # 
    # radioButton_traceEnable
    # 
    $radioButton_traceEnable.AutoSize = $true;
    $radioButton_traceEnable.Checked = $true;
    $radioButton_traceEnable.Location = New-Object System.Drawing.Point(20, 34);
    $radioButton_traceEnable.Name = "radioButton_traceEnable";
    $radioButton_traceEnable.Size = New-Object System.Drawing.Size(58, 17);
    $radioButton_traceEnable.TabIndex = 1;
    $radioButton_traceEnable.TabStop = $true;
    $radioButton_traceEnable.Text = "Enable";
    $radioButton_traceEnable.UseVisualStyleBackColor = $true;
    # 
    # groupBox_sessionAdmin
    # 
    $groupBox9.Controls.Add($radioButton_SessionAdmin_Manual);
    $groupBox9.Controls.Add($radioButton_SessionAdmin_Auto);
    $groupBox9.Location = New-Object System.Drawing.Point(574, 28);
    $groupBox9.Name = "groupBox_sessionAdmin";
    $groupBox9.Size = New-Object System.Drawing.Size(185, 92);
    $groupBox9.TabIndex = 6;
    $groupBox9.TabStop = $false;
    $groupBox9.Text = "Session Admin";
    # 
    # radioButton_SessionAdmin_Manual
    # 
    $radioButton_SessionAdmin_Manual.AutoSize = $true;
    $radioButton_SessionAdmin_Manual.Location = New-Object System.Drawing.Point(20, 57);
    $radioButton_SessionAdmin_Manual.Name = "radioButton_SessionAdmin_Manual";
    $radioButton_SessionAdmin_Manual.Size = New-Object System.Drawing.Size(60, 17);
    $radioButton_SessionAdmin_Manual.TabIndex = 2;
    $radioButton_SessionAdmin_Manual.Text = "Manual";
    $radioButton_SessionAdmin_Manual.UseVisualStyleBackColor = $true;
    # 
    # radioButton_SessionAdmin_Auto
    # 
    $radioButton_SessionAdmin_Auto.AutoSize = $true;
    $radioButton_SessionAdmin_Auto.Checked = $true;
    $radioButton_SessionAdmin_Auto.Location = New-Object System.Drawing.Point(20, 34);
    $radioButton_SessionAdmin_Auto.Name = "radioButton_SessionAdmin_Auto";
    $radioButton_SessionAdmin_Auto.Size = New-Object System.Drawing.Size(47, 17);
    $radioButton_SessionAdmin_Auto.TabIndex = 1;
    $radioButton_SessionAdmin_Auto.TabStop = $true;
    $radioButton_SessionAdmin_Auto.Text = "Auto";
    $radioButton_SessionAdmin_Auto.UseVisualStyleBackColor = $true;

    # 
    # Form1
    # 
    #$AutoScaleDimensions = New-Object System.Drawing.SizeF(6F, 13F);
    $form1.AutoScaleDimensions = New-Object System.Drawing.SizeF(6, 13);
    $form1.AutoScaleMode = [System.Windows.Forms.AutoScaleMode]::Font;
    $form1.ClientSize = New-Object System.Drawing.Size(867, 496);
    $form1.MinimumSize = $form1.Size
    #$form1.MaximumSize = $form1.Size     # retrait sezz 
    $form1.Name = "Form1";
    $form1.Text = " $NomDeBase : une aide à l'injection de modifications dans Winpe 10 version 1903 build 18362.19h1 et V1909";
    # 2 ajouts sezz
    $form1.StartPosition = [System.Windows.Forms.FormStartPosition]::CenterScreen;
    $form1.Font = New-Object System.Drawing.Font("Segoe UI", 9, [System.Drawing.FontStyle]::Regular, [System.Drawing.GraphicsUnit]::Point, 0);

    #
    # ajout des controls à la form
    #
    $form1.Controls.Add($button_Excution);
    $form1.Controls.Add($statusStrip1);
    $form1.Controls.Add($button_Exit);
    #$form1.Controls.Add($button_GetInfoWim);   #inutile avec les event textchanged des textbox 
    $form1.Controls.Add($tabControl1);
    #$form1.Load += New-Object System.EventHandler($Form1_Load);
    
    # activation des layout
    $tabControl1.ResumeLayout($false);
    $tabControl1.PerformLayout()
    $tabPage_Presentation.ResumeLayout($false);
    $tabPage_Presentation.PerformLayout()
    $tabPage_Saisie.ResumeLayout($false);
    $groupBox4.ResumeLayout($false);
    $groupBox4.PerformLayout()
    $groupBox3.ResumeLayout($false);
    $groupBox3.PerformLayout()
    $groupBox2.ResumeLayout($false);
    $groupBox2.PerformLayout()
    $groupBox1.ResumeLayout($false);
    $groupBox1.PerformLayout()
    $tabPage_Configuration.ResumeLayout($false);
    $tabPage_Configuration.PerformLayout()
    $tabPage_Console.ResumeLayout($false);
    $tabPage_Console.PerformLayout()
    $statusStrip1.ResumeLayout($false);
    $statusStrip1.PerformLayout()
    $groupBox5.ResumeLayout($false);
    $groupBox5.PerformLayout()
    $groupBox6.ResumeLayout($false);
    $groupBox6.PerformLayout()
    $groupBox7.ResumeLayout($false);
    $groupBox7.PerformLayout()
    $groupBox8.ResumeLayout($false);
    $groupBox8.PerformLayout();
    $groupBox9.ResumeLayout($false);
    $groupBox9.PerformLayout();

    $form1.ResumeLayout($false);
    $form1.PerformLayout()
#endregion the controls

#region timer
$timer = New-Object System.Windows.Forms.Timer
$timer.Interval = 1000
$TimerAction = {
    #$toolStripStatusLabel_Date.Text = "$(get-date -Format ‘HH:mm:ss’)";
    $toolStripStatusLabel_Date.Text = "$(get-date -Format F)";
    # détection de la fin du traitement, on active la navigation dans les onglets
    if ($button_Excution.Enabled -or $global:so.error){
        $tabControl1.Enabled = $true
    }
}
$timer.add_tick($TimerAction)
$timer.Enabled = $true
#endregion timer

#pour lire et comparer la version de winpe et de la référence
$textBox_RefWindows.add_TextChanged($textBox_RefWindows_TextChanged)
$textBox_Racine.add_TextChanged($textBox_Racine_TextChanged)

#region ajout event handler pour form1
$form1.add_closed({Show-Console})
#Save the initial state of the form
$InitialFormWindowState = $form1.WindowState
#Init the OnLoad event to correct the initial state of the form
$form1.add_Load($OnLoadForm_StateCorrection)
# détection action clavier
$form1.KeyPreview=$true
$form1.Add_KeyUp($form1_KeyControle)
#endregion ajout event handler pour form1

#$ErrorActionPreference="stop"

# pour charger et décharger les ruches
enable-privilege SeRestorePrivilege
enable-privilege SeBackupPrivilege

# les objets synchronisant l'exécution des tâches et l'ihm
# http://blogs.technet.com/b/heyscriptingguy/archive/2011/06/16/use-asynchronous-event-handling-in-powershell.aspx

# $global:EventExecutionCompleted = New-Object System.Threading.ManualResetEvent($false) : pas d'event nommé !
# en raison du pb de libération des objets, j'utilise le mode ManualReset pour l'event "nommé"
#$global:ewh = New-Object System.Threading.EventWaitHandle($false,[System.Threading.EventResetMode]::AutoReset,"ewhFinDesTraitements")
$global:ewhDebutDesTraitements = New-Object System.Threading.EventWaitHandle($false,[System.Threading.EventResetMode]::ManualReset,"ewhDebutDesTraitements")
# $myEwh = [System.Threading.EventWaitHandle]::OpenExisting("ewhFinDesTraitements");

# l'objet magique qui permet de lire/écrire son contenu "multiple" car la hashtable peut avoir plusieurs entrées
$global:so = [hashtable]::Synchronized(@{
    'MaForm'            = $form1
    'LaConsole'         = $textBox_Console
    'BoutonExecution'   = $button_Excution
    'Pourcentage'       = $toolStripStatusLabel_Dism
    'MonPSScriptRoot'   = $MonPSScriptRoot
    'Racine'            = ""
    'SrcAdk'            = ""
    'RefWindows'        = ""
    'Langue'            = $null
    'LoadUnloadRegExe'  = $false
    'full_SrcSoftware'  = $false
    'SessionAdmin_Auto' = $false
    'NetworkTrace'      = $false
    'error'             = $false
})

# lecture du fichier de config et préparation des saisies
init

# création d'un runspace pour lancer les traitements : 
#    charger un script depuis un fichier et le lancer
#    le début du traitement sera signalé par un event
#    la fin du traitement sera détectée par le timer qui scrute l'état du bouton 'Build' et la variable 'error'
#    on utilise la hashtable synchronisée passée en paramètre permettant l'accés aux "controls"

CreationDuRunspaceDesTraitements

#Show the Form
$form1.ShowDialog()| Out-Null
}#end SB

#region fonctions du main
function Test-Admin (){
    # vérifier les droits admin : pour avoir une messagebox plus sympa que le msg de PS
    $identity = [Security.Principal.WindowsIdentity]::GetCurrent()
    $principal = new-object Security.Principal.WindowsPrincipal $identity
    if ( ! $principal.IsInRole([Security.Principal.WindowsBuiltInRole]::Administrator) )
    {
	    MaMessagebox "Il faut lancer powershell en tant qu'administrateur et activer l'exécution des scripts !"
	    #$Host.UI.RawUI.ReadKey()
        # pb 1 : si clic droit pour lancer ce script alors attendre la fin du runspace sinon le ps se termine
        # if (!([Security.Principal.WindowsPrincipal][Security.Principal.WindowsIdentity]::GetCurrent()).IsInRole([Security.Principal.WindowsBuiltInRole] "Administrator")) { Start-Process powershell.exe "-NoProfile -ExecutionPolicy Bypass -File `"$PSCommandPath`"" -Verb RunAs; exit } 
        #$arguments = "& '" + $PSCommandPath + "'"
        #Start-Process powershell -Verb runAs -ArgumentList $arguments
	    break
    }
}
function MaMessagebox( [string]$msg, [string] $icone="Information"){
    # V2 et V3 [void][reflection.assembly]::loadwithpartialname("system.windows.forms")
    Add-Type -AssemblyName "system.windows.forms"
    [void][System.Windows.Forms.MessageBox]::Show(
        $msg, 
        $MyInvocation.ScriptName, 
        [System.Windows.Forms.MessageBoxButtons]::OK, 
        $icone#[System.Windows.Forms.MessageBoxIcon]::Information
    )
}

#endregion fonctions du main

#region Main

# à faire : créer un mutex pour une instance unique
# http://www.dotnetperls.com/mutex

# test si os = 64 bits
if ( $Env:PROCESSOR_ARCHITECTURE -ne "AMD64"){
    MaMessagebox "Ce script nécessite un OS 64 bits et traite uniquement Winpe64." "ERROR"
    break
}

Test-Admin

# test de la présence des fichiers nécessaires
$fileTraitement            = join-path $PSScriptRoot "traitement.ps1"
$fileWifiConnexion         = join-path $PSScriptRoot "WifiConnexion.ps1"
$fileProductOptions        = join-path $PSScriptRoot "ProductOptions.txt"
$fileStateRepository1      = join-path $PSScriptRoot "StateRepository-Deployment.srd"
$fileStateRepository2      = join-path $PSScriptRoot "StateRepository-Machine.srd"
$fileTerminalServer        = join-path $PSScriptRoot "TerminalServer.txt"
$fileEnglishText           = join-path $PSScriptRoot "English.txt"
$fileScreenResolution      = join-path $PSScriptRoot "IHM_Get-Set_WinpeScreenResolution.PS1"
#ajout V1903 pour printers
$fileNotificationsOobeComplete = join-path $PSScriptRoot "NotificationsOobeComplete.txt"
# retrait avec v1809
#$fileSetWow64         = join-path $PSScriptRoot "MonSetWow64.ps1"
#$fileModifyTheme      = join-path $PSScriptRoot "modify-themecpl.PS1"

$fileToTest = @($fileTraitement, $fileWifiConnexion,
                $fileProductOptions, $fileEnglishText, $fileScreenResolution,
                #$fileSetWow64, $fileModifyTheme, $fileViewPrinters,
                $fileStateRepository1, $fileStateRepository2, 
                $fileTerminalServer, $fileNotificationsOobeComplete)
$fileToTest  | %{   
    if ( ! (test-path $_)){
        MaMessagebox "Ce script nécessite le fichier $_." "ERROR"
        break
    }
}

#
# comment est lancé ce script ?
#
#    - depuis une console PS ? C'est le seul cas traité actuellement (sinon  impact sur myInvoation et pb 1 voir plus loin)
#    - à partir d'un click droit sur le script puis 'executer avec powershell' ?

# utilisé pour construire le chemin du flux altenatif contenant la 'config'
# valide avec les runspace uniquement sinon $myinvocation.mycommand.definition (voir plus loin)
$scriptName = $MyInvocation.MyCommand
if ($scriptName -eq $null){
    $scriptName = split-path $MyInvocation.InvocationName
}

if ( $Debug )
{
    write-host "La console Ps recevra les write-host de l'ihm"
    # les autres variables sont accessibles
    $MonPSScriptRoot = $PSScriptRoot
    #$MonScript = $scriptName # mise en commentaire afin de rendre visible le fichier de config
    & $sb 
}else{
    write-host "Démarrage du Runspace dans quelques secondes, la console PS sera masquée ..."
    $rs = [RunspaceFActory]::CreateRunSpace()
    $rs.ApartmentState = "STA"
    $rs.ThreadOptions = "ReuseThread"
    $rs.Open()
    $ps = [Powershell]::Create()
    $ps.Runspace = $rs

    # les variables envoyées dans le runspace
    $ps.Runspace.SessionStateProxy.SetVariable("PidParent", $Pid)
    $ps.Runspace.SessionStateProxy.SetVariable("MonPSScriptRoot", $PSScriptRoot)
    $ps.Runspace.SessionStateProxy.SetVariable("MonScript", $scriptName)
    $ps.Runspace.SessionStateProxy.SetVariable("fileTraitement", $fileTraitement)    
    $ps.Runspace.SessionStateProxy.SetVariable("fileWifiConnexion", $fileWifiConnexion)    
    $ps.Runspace.SessionStateProxy.SetVariable("fileProductOptions", $fileProductOptions)
    $ps.Runspace.SessionStateProxy.SetVariable("fileStateRepository1", $fileStateRepository1) 
    $ps.Runspace.SessionStateProxy.SetVariable("fileStateRepository2", $fileStateRepository2)
    $ps.Runspace.SessionStateProxy.SetVariable("fileTerminalServer", $fileTerminalServer)
    $ps.Runspace.SessionStateProxy.SetVariable("fileEnglishText", $fileEnglishText)
    $ps.Runspace.SessionStateProxy.SetVariable("fileScreenResolution", $fileScreenResolution)
    #$ps.Runspace.SessionStateProxy.SetVariable("fileSetWow64", $fileSetWow64)    
    #$ps.Runspace.SessionStateProxy.SetVariable("fileModifyTheme", $fileModifyTheme)
    # ajout v1903
    $ps.Runspace.SessionStateProxy.SetVariable("fileNotificationsOobeComplete", $fileNotificationsOobeComplete)
       
  
    # note : c# peut aussi lancer un script ps
    #static void Main(string[] args)
    #{
    #    PowerShell ps = PowerShell.Create();
    #    ps.AddScript(@"c:\test\test.ps1").AddParameter("param1", "paramvalue1");
    #    ps.Invoke();
    #}

    # on pourrait passer des paramètres au script
    #$handle = $ps.Addscript($sb).AddParameter("param1", "paramvalue1").BeginInvoke()

    # on lance le Runspace
    $handle = $ps.Addscript($sb).BeginInvoke()

    # pb 1 : attendre la fin du runspace si ce script est lancé par un clic droit
}
#endregion Main