# but : crer les objets ncessaires pour le sous-systme 32 bits sur Winpe afin de lancer winobj.exe

# attention : pour ne pas lancer ce code sur une machine windows, le privilge ??? n'est pas activ
#             Sur Winpe, ce privilge est inutile. Pourquoi ?

#v0.0.0.1.a

# c:\Windows\Microsoft.NET\Framework\v4.0.30319\csc.exe  /target:exe   /out:.\Desktop\MonSetWow64.exe   .\Desktop\MonSetWow64.txt

#http://undocumented.ntinternals.net/index.html?page=UserMode%2FUndocumented%20Functions%2FNT%20Objects%2FDirectoryObject%2FNtQueryDirectoryObject.html
#http://www.pinvoke.net/default.aspx/ntdll/NtOpenDirectoryObject.html

param( [switch]$create = $false )

$code = @'
using System;
using System.IO;
using System.Runtime.InteropServices;
using Microsoft.Win32;
using Microsoft.Win32.SafeHandles;

namespace MonSetWow64 {
    public class SetWow64 {

        [DllImport("ntdll.dll")]
         public static extern int NtClose(
            SafeFileHandle h);

        [DllImport("ntdll.dll")]
         public static extern int NtCreateDirectoryObject(
            out SafeFileHandle DirectoryHandle,
            uint DesiredAccess,
            ref OBJECT_ATTRIBUTES ObjectAttributes);

        [DllImport("ntdll.dll")]
         public static extern int NtOpenDirectoryObject(
            out SafeFileHandle DirectoryHandle,
            uint DesiredAccess,
            ref OBJECT_ATTRIBUTES ObjectAttributes);

        [DllImport("ntdll.dll")]
         public static extern int NtQueryDirectoryObject(
            SafeFileHandle DirectoryHandle,
            IntPtr Buffer,
            int Length,
            bool ReturnSingleEntry,
            bool RestartScan,
            ref uint Context,
            out uint ReturnLength);

        [DllImport("ntdll.dll")]
         public static extern int NtCreateSymbolicLinkObject(
            out SafeFileHandle DirectoryHandle,
            uint DesiredAccess,
            ref OBJECT_ATTRIBUTES ObjectAttributes,
            ref UNICODE_STRING name );

        [StructLayout(LayoutKind.Sequential)]
         public struct UNICODE_STRING : IDisposable
         {
            public ushort Length;
            public ushort MaximumLength;
            private IntPtr buffer;

            public UNICODE_STRING(string s)
            {
              Length = (ushort)(s.Length * 2);
              MaximumLength = (ushort)(Length + 2);
              buffer = Marshal.StringToHGlobalUni(s);
            }

            public void Dispose()
            {
              Marshal.FreeHGlobal(buffer);
              buffer = IntPtr.Zero;
            }

            public override string ToString()
            {
              return Marshal.PtrToStringUni(buffer);
            }
         }

        [StructLayout(LayoutKind.Sequential)]
         public struct OBJECT_DIRECTORY_INFORMATION
         {
            public UNICODE_STRING Name;
            public UNICODE_STRING TypeName;
         }

        [StructLayout(LayoutKind.Sequential)]
         public struct OBJECT_ATTRIBUTES : IDisposable
         {
            public int Length;
            public IntPtr RootDirectory;
            private IntPtr objectName;
            public uint Attributes;
            public IntPtr SecurityDescriptor;
            public IntPtr SecurityQualityOfService;

            public OBJECT_ATTRIBUTES(string name, uint attrs)
            {
              Length = 0;
              RootDirectory = IntPtr.Zero;
              objectName = IntPtr.Zero;
              Attributes = attrs;
              SecurityDescriptor = IntPtr.Zero;
              SecurityQualityOfService = IntPtr.Zero;

              Length = Marshal.SizeOf(this);
              ObjectName = new UNICODE_STRING(name);
            }

            public UNICODE_STRING ObjectName
            {
              get
              {
               return (UNICODE_STRING)Marshal.PtrToStructure(
                objectName, typeof(UNICODE_STRING));
              }

              set
              {
               bool fDeleteOld = objectName != IntPtr.Zero;
               if (!fDeleteOld)
                objectName = Marshal.AllocHGlobal(Marshal.SizeOf(value));
               Marshal.StructureToPtr(value, objectName, fDeleteOld);
              }
            }

            public void Dispose()
            {
              if (objectName != IntPtr.Zero)
              {
                Marshal.DestroyStructure(objectName, typeof(UNICODE_STRING));
                Marshal.FreeHGlobal(objectName);
                objectName = IntPtr.Zero;
              }
            }
         }

        public static void ObjectDisplay()
         {
            SafeFileHandle h;
            var attr = new OBJECT_ATTRIBUTES("\\", 0);
            //var st = Win32.NtOpenDirectoryObject(
            var st = NtOpenDirectoryObject(
              out h, 1, ref attr);
            if (st < 0) return;

            var bufsz = 1024;
            var buf = Marshal.AllocHGlobal(bufsz);
            uint context = 0, len;
            for (; ; )
            {
              st =  NtQueryDirectoryObject(h, buf, bufsz,
                true, context == 0, ref context, out len);
              if (st < 0) break;

              var odi = (OBJECT_DIRECTORY_INFORMATION)
                Marshal.PtrToStructure(buf, typeof(OBJECT_DIRECTORY_INFORMATION));
              //System.Diagnostics.Debug.Print(
              Console.WriteLine(  
	        "0x{0:X2}:{1,-25}{2}", context, odi.TypeName, odi.Name);
            }
            Marshal.FreeHGlobal(buf);
            h.Dispose();
         }

        public static void ObjectCreate()
        {
            SafeFileHandle DirectoryHandle, LinkHandle;
	
	        var MonObjectAttributes = new OBJECT_ATTRIBUTES("\\KnownDlls32", OBJ_CASE_INSENSITIVE | OBJ_PERMANENT);

	        Console.WriteLine("Pour crer une entre ...");
	        // error 0xc0000061 si le privilge ( mais lequel ?) n'est pas actif : privilge inutil dans winpe ! pourquoi ?
	        // error 0xc0000035 si le directory existe dj

	        // Add \\KnownDlls32 DirectoryObject
	        var st = NtCreateDirectoryObject(
		        out DirectoryHandle,
		        DIRECTORY_ALL_ACCESS,
		        ref MonObjectAttributes);
	        //if ( (st < 0)  && (st != 0x0000035)) {
	        if ( (st < 0)  && (st != -1073741771)) {
		        Console.WriteLine("Erreur NtCreateDirectoryObject : {0:x} {0:d}",st);
		        return;
	        }

	        // http://www.pinvoke.net/default.aspx/ntdll.NtCreateFile
	        var usSysWoW64 = new UNICODE_STRING("X:\\Windows\\SysWow64");
	        var MonObjectAttributes2 = new OBJECT_ATTRIBUTES("\\KnownDlls32\\KnownDllPath", OBJ_CASE_INSENSITIVE | OBJ_PERMANENT);

	        // Add \\KnownDlls32\\KnownDllPath SymbolicLink
	        var r = NtCreateSymbolicLinkObject(
		        out LinkHandle,
		        SYMBOLIC_LINK_ALL_ACCESS,
		        ref MonObjectAttributes2,
		        ref usSysWoW64);
	        if (r < 0) {
		        Console.WriteLine("Erreur NtCreateSymbolicLinkObject : {0:x} {0:d}",st);
		        return;
	        }

	        NtClose(LinkHandle);

	        NtClose(DirectoryHandle);
        }

        // http://www.pinvoke.net/default.aspx/ntdll.ntcreatefile
        public static UInt32 OBJ_CASE_INSENSITIVE = 0x40;
        public static UInt32 OBJ_PERMANENT = 0x00000010;
        public static UInt32 STANDARD_RIGHTS_REQUIRED = 0x000F0000;
        public static UInt32 DIRECTORY_ALL_ACCESS = (STANDARD_RIGHTS_REQUIRED | 0xF);
        public static UInt32 SYMBOLIC_LINK_ALL_ACCESS = (STANDARD_RIGHTS_REQUIRED | 0x1);

        static void Main ()
        {
	        Console.WriteLine("Pour enumrer les objets...");
	        ObjectDisplay();

	        Console.WriteLine("Pour crer les objets...");
            ObjectCreate();

	        Console.WriteLine("Pour vrifier la cration des objets...");
	        ObjectDisplay();
        } // end Main
    } // end class
} // end namespace
'@

if (-not ("MonSetWow64.SetWow64" -as [Type]))
{
    Add-Type  -TypeDefinition $code 
}


# pour visualiser les objets du systme
[MonSetWow64.SetWow64]::ObjectDisplay()

if ($create){
    # pour crer les objets ncessaires au sous-systme 32 bits
    [MonSetWow64.SetWow64]::ObjectCreate()
}
